package cn.kdan.compdf.service;

import cn.kdan.compdf.dto.AddNewWebhookDTO;
import cn.kdan.compdf.dto.EditWebhookDTO;
import cn.kdan.compdf.entity.BackgroundUserWebhook;
import cn.kdan.compdf.vo.BackgroundEventVO;
import cn.kdan.compdf.vo.BackgroundUserWebhookVO;
import com.baomidou.mybatisplus.extension.service.IService;
import com.baomidou.mybatisplus.core.metadata.IPage;

import java.util.List;

/**
 * @author comPDF-Kit WPH 2022-10-09
 */
public interface BackgroundUserWebhookService extends IService<BackgroundUserWebhook> {

    /**
     * 列表查询
     * @param query 查询参数
     * @return 列表数据
     */
    IPage<BackgroundUserWebhook> page(BackgroundUserWebhook query);

    /**
     * 获取Webhooks列表
     * @param userId 用户id
     * @return 用户Webhooks列表
     */
    List<BackgroundUserWebhookVO> getWebhookList(Long userId);

    /**
     * 获取系统所有事件
     * @return 系统所有事件
     */
    List<BackgroundEventVO> getEventList();

    List<Long> getEnableEventIdList(Long webhookId);

    /**
     * 添加新Webhook
     * @param addNewWebhookDTO 请求
     */
    void addNewWebhook(AddNewWebhookDTO addNewWebhookDTO);

    void editWebhook(EditWebhookDTO editWebhookDTO);

    void deleteById(Long id);
}